/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#ifndef mozilla_dom_SelectionStateChangedEventBinding_h
#define mozilla_dom_SelectionStateChangedEventBinding_h

#include "EventBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/DOMRect.h"
#include "mozilla/dom/Nullable.h"

namespace mozilla {
namespace dom {

class DOMRectReadOnly;
struct NativePropertyHooks;
class ProtoAndIfaceCache;
class SelectionStateChangedEvent;
struct SelectionStateChangedEventAtoms;
struct SelectionStateChangedEventInitAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

MOZ_BEGIN_ENUM_CLASS(SelectionState, uint32_t)
  Drag,
  Mousedown,
  Mouseup,
  Keypress,
  Selectall,
  Collapsetostart,
  Collapsetoend,
  Blur,
  Updateposition,
  EndGuard_
MOZ_END_ENUM_CLASS(SelectionState)

namespace SelectionStateValues {
extern const EnumEntry strings[10];
} // namespace SelectionStateValues


struct SelectionStateChangedEventInit : public EventInit
{
  nsRefPtr<mozilla::dom::DOMRectReadOnly> mBoundingClientRect;
  nsString mSelectedText;
  Sequence<SelectionState> mStates;
  bool mVisible;

  SelectionStateChangedEventInit();

  explicit inline SelectionStateChangedEventInit(const SelectionStateChangedEventInit& aOther)
  {
    *this = aOther;
  }

protected:
  explicit inline SelectionStateChangedEventInit(int )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  static bool
  InitIds(JSContext* cx, SelectionStateChangedEventInitAtoms* atomsCache);

public:
  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  void
  operator=(const SelectionStateChangedEventInit& aOther);
};

namespace binding_detail {
struct FastSelectionStateChangedEventInit : public SelectionStateChangedEventInit
{
  inline FastSelectionStateChangedEventInit()
    : SelectionStateChangedEventInit(42)
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace SelectionStateChangedEventBinding {

  typedef mozilla::dom::SelectionStateChangedEvent NativeType;

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  JSObject*
  DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal);

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  JSObject*
  Wrap(JSContext* aCx, mozilla::dom::SelectionStateChangedEvent* aObject, nsWrapperCache* aCache);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject)
  {
    return Wrap(aCx, aObject, aObject);
  }

  void
  ClearCachedStatesValue(mozilla::dom::SelectionStateChangedEvent* aObject);

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal);

} // namespace SelectionStateChangedEventBinding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_SelectionStateChangedEventBinding_h
