/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsINetworkInterceptController.idl
 */

#ifndef __gen_nsINetworkInterceptController_h__
#define __gen_nsINetworkInterceptController_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIHttpChannelInternal; /* forward declaration */

class nsIOutputStream; /* forward declaration */

class nsIURI; /* forward declaration */


/* starting interface:    nsIInterceptedChannel */
#define NS_IINTERCEPTEDCHANNEL_IID_STR "0b5f82a7-5824-4a0d-bf5c-8a8a7684c0c8"

#define NS_IINTERCEPTEDCHANNEL_IID \
  {0x0b5f82a7, 0x5824, 0x4a0d, \
    { 0xbf, 0x5c, 0x8a, 0x8a, 0x76, 0x84, 0xc0, 0xc8 }}

class NS_NO_VTABLE nsIInterceptedChannel : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IINTERCEPTEDCHANNEL_IID)

  /* void resetInterception (); */
  NS_IMETHOD ResetInterception(void) = 0;

  /* void synthesizeHeader (in ACString name, in ACString value); */
  NS_IMETHOD SynthesizeHeader(const nsACString & name, const nsACString & value) = 0;

  /* void finishSynthesizedResponse (); */
  NS_IMETHOD FinishSynthesizedResponse(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIInterceptedChannel, NS_IINTERCEPTEDCHANNEL_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIINTERCEPTEDCHANNEL \
  NS_IMETHOD ResetInterception(void) MOZ_OVERRIDE; \
  NS_IMETHOD SynthesizeHeader(const nsACString & name, const nsACString & value) MOZ_OVERRIDE; \
  NS_IMETHOD FinishSynthesizedResponse(void) MOZ_OVERRIDE; 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIINTERCEPTEDCHANNEL(_to) \
  NS_IMETHOD ResetInterception(void) MOZ_OVERRIDE { return _to ResetInterception(); } \
  NS_IMETHOD SynthesizeHeader(const nsACString & name, const nsACString & value) MOZ_OVERRIDE { return _to SynthesizeHeader(name, value); } \
  NS_IMETHOD FinishSynthesizedResponse(void) MOZ_OVERRIDE { return _to FinishSynthesizedResponse(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIINTERCEPTEDCHANNEL(_to) \
  NS_IMETHOD ResetInterception(void) MOZ_OVERRIDE { return !_to ? NS_ERROR_NULL_POINTER : _to->ResetInterception(); } \
  NS_IMETHOD SynthesizeHeader(const nsACString & name, const nsACString & value) MOZ_OVERRIDE { return !_to ? NS_ERROR_NULL_POINTER : _to->SynthesizeHeader(name, value); } \
  NS_IMETHOD FinishSynthesizedResponse(void) MOZ_OVERRIDE { return !_to ? NS_ERROR_NULL_POINTER : _to->FinishSynthesizedResponse(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsInterceptedChannel : public nsIInterceptedChannel
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIINTERCEPTEDCHANNEL

  nsInterceptedChannel();

private:
  ~nsInterceptedChannel();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsInterceptedChannel, nsIInterceptedChannel)

nsInterceptedChannel::nsInterceptedChannel()
{
  /* member initializers and constructor code */
}

nsInterceptedChannel::~nsInterceptedChannel()
{
  /* destructor code */
}

/* void resetInterception (); */
NS_IMETHODIMP nsInterceptedChannel::ResetInterception()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void synthesizeHeader (in ACString name, in ACString value); */
NS_IMETHODIMP nsInterceptedChannel::SynthesizeHeader(const nsACString & name, const nsACString & value)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void finishSynthesizedResponse (); */
NS_IMETHODIMP nsInterceptedChannel::FinishSynthesizedResponse()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsINetworkInterceptController */
#define NS_INETWORKINTERCEPTCONTROLLER_IID_STR "b3ad3e9b-91d8-44d0-a0c5-dc2e9374f599"

#define NS_INETWORKINTERCEPTCONTROLLER_IID \
  {0xb3ad3e9b, 0x91d8, 0x44d0, \
    { 0xa0, 0xc5, 0xdc, 0x2e, 0x93, 0x74, 0xf5, 0x99 }}

class NS_NO_VTABLE nsINetworkInterceptController : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_INETWORKINTERCEPTCONTROLLER_IID)

  /* bool shouldPrepareForIntercept (in nsIURI aURI); */
  NS_IMETHOD ShouldPrepareForIntercept(nsIURI *aURI, bool *_retval) = 0;

  /* void channelIntercepted (in nsIInterceptedChannel aChannel, in nsIOutputStream aStream); */
  NS_IMETHOD ChannelIntercepted(nsIInterceptedChannel *aChannel, nsIOutputStream *aStream) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsINetworkInterceptController, NS_INETWORKINTERCEPTCONTROLLER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSINETWORKINTERCEPTCONTROLLER \
  NS_IMETHOD ShouldPrepareForIntercept(nsIURI *aURI, bool *_retval) MOZ_OVERRIDE; \
  NS_IMETHOD ChannelIntercepted(nsIInterceptedChannel *aChannel, nsIOutputStream *aStream) MOZ_OVERRIDE; 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSINETWORKINTERCEPTCONTROLLER(_to) \
  NS_IMETHOD ShouldPrepareForIntercept(nsIURI *aURI, bool *_retval) MOZ_OVERRIDE { return _to ShouldPrepareForIntercept(aURI, _retval); } \
  NS_IMETHOD ChannelIntercepted(nsIInterceptedChannel *aChannel, nsIOutputStream *aStream) MOZ_OVERRIDE { return _to ChannelIntercepted(aChannel, aStream); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSINETWORKINTERCEPTCONTROLLER(_to) \
  NS_IMETHOD ShouldPrepareForIntercept(nsIURI *aURI, bool *_retval) MOZ_OVERRIDE { return !_to ? NS_ERROR_NULL_POINTER : _to->ShouldPrepareForIntercept(aURI, _retval); } \
  NS_IMETHOD ChannelIntercepted(nsIInterceptedChannel *aChannel, nsIOutputStream *aStream) MOZ_OVERRIDE { return !_to ? NS_ERROR_NULL_POINTER : _to->ChannelIntercepted(aChannel, aStream); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsNetworkInterceptController : public nsINetworkInterceptController
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSINETWORKINTERCEPTCONTROLLER

  nsNetworkInterceptController();

private:
  ~nsNetworkInterceptController();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsNetworkInterceptController, nsINetworkInterceptController)

nsNetworkInterceptController::nsNetworkInterceptController()
{
  /* member initializers and constructor code */
}

nsNetworkInterceptController::~nsNetworkInterceptController()
{
  /* destructor code */
}

/* bool shouldPrepareForIntercept (in nsIURI aURI); */
NS_IMETHODIMP nsNetworkInterceptController::ShouldPrepareForIntercept(nsIURI *aURI, bool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void channelIntercepted (in nsIInterceptedChannel aChannel, in nsIOutputStream aStream); */
NS_IMETHODIMP nsNetworkInterceptController::ChannelIntercepted(nsIInterceptedChannel *aChannel, nsIOutputStream *aStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsINetworkInterceptController_h__ */
